<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Task 30.10</title>
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.6.2/dist/css/bootstrap.min.css">
</head>

<body onload="onPageLoading()">
    <div class="container">
        <h1 class="text-center">Form đăng nhập</h1>
        <form id="loginForm">
            <div class="row">
                <div class="col-sm-12 group-control">
                    <label for="inp-email">Email address</label>
                    <input class="form-control" type="text" id="inp-email" placeholder="Enter Email" />
                    <p style="color:#959da0">We'll never share your email with anyone else</p>
                </div>
            </div>
            <div class="row">
                <div class="col-sm-12 group-control">
                    <label for="inp-password">Password</label>
                    <input class="form-control" type="password" id="inp-password" placeholder="Enter password" />
                </div>
            </div>
            <div class="row mt-4">
                <div class="col-sm-12 group-control">
                    <button type="submit" class="btn btn-primary">Submit</button>
                </div>
            </div>
        </form>
    </div>
</body>
<script>
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_STATUS_CREATED = 201;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    const gBASE_URL = "https://62458c222cfed18817229118.mockapi.io/users";
    const gBASE_URL_CONTACTS = "https://62458c222cfed18817229118.mockapi.io/contacts";
    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function onPageLoading() {
        var vForm = document.getElementById("loginForm");
        vForm.addEventListener("submit", function (e) {
            e.preventDefault(); // Ngăn chặn submit mặc định
            console.log("Bạn đang submit form!");
            // Bước 0: Tạo đối tượng chứa dữ liệu cần thu thập
            var vObject = {
                email: "",
                password: ""
            }
            // Bước 1: Thu thập dữ liệu
            getDataFromInput(vObject);
            console.log(vObject);
            // Bước 2: Kiểm tra dữ liệu thu thập
            var vCheck = validateData(vObject);
            console.log(vCheck);
            if (vCheck == true) {
                // Bước 3: Xử lý ajax
                // create a request
                var vXmlHttpLogin = new XMLHttpRequest();
                processAjax(vXmlHttpLogin, vObject);
                // Bước 4: Hiển thị
                vXmlHttpLogin.onreadystatechange =
                    function () {
                        if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                            var vLoginInfo = vXmlHttpLogin.responseText;
                            console.log(vLoginInfo);
                            var vObjectInfor = JSON.parse(vLoginInfo);
                            displayData(vObjectInfor);
                        }
                    }
            }


        })
    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    // Hàm hiển thị dữ liệu
    // Input là đối tượng dữ liệu cần hiển thị
    function displayData(paramData){
        "use strict";
        console.log("Đăng nhập thành công!");
    }
    // Hàm xử lý Ajax cho đăng nhập
    // input là đối tượng request và đối tượng dữ liệu
    function processAjax(paramRequest, paramObject) {
        "use strict";
        paramRequest.open("GET", gBASE_URL + "?" + paramObject.toString(), true);
        paramRequest.send();
    }
    // Hàm kiểm tra email
    // Input là email cần kiểm tra
    // output là true / false
    function validateEmail(email) {
        var re = /\S+@\S+\.\S+/;
        return re.test(email);
    }
    // Hàm kiểm tra dữ liệu thu thập
    // Input là dữ liệu cần kiểm tra
    // Output là true / false
    function validateData(paramObject) {
        "use strict";
        var vResult = true;
        var vEmail = paramObject.email.trim();
        var vPass = paramObject.password.trim();

        if (vPass == "") {
            alert("Password is empty!");
            vResult = false;
        }

        if (vEmail == "") {
            alert("Email is empty!");
            vResult = false;
        } else {
            if (validateEmail(vEmail) == false) {
                alert("Email is invalid!");
                vResult = false;
            }
        }

        return vResult;
    }
    // Hàm thu thập dữ liệu
    // Input là đối tượng chứa dữ liệu cần thu thập
    function getDataFromInput(paramObject) {
        "use strict";
        var vEmail = document.getElementById("inp-email"); // Truy xuất phần tử thông qua ID và lưu vào biến
        paramObject.email = vEmail.value;
        var vPass = document.getElementById("inp-password"); // Truy xuất phần tử thông qua ID và lưu vào biến
        paramObject.password = vPass.value;
    }
</script>

</html>